Open CASCADE Technology: ShapeAnalysis_FreeBounds Class Reference

Open CASCADE Technology 6.9.1

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions
ShapeAnalysis_FreeBounds Class Reference

This class is intended to output free bounds of the shape (free bounds are the wires consisting of edges referenced by the only face). This class works on two distinct types of shapes when analyzing their free bounds: More...

`#include <ShapeAnalysis_FreeBounds.hxx>`

## Public Member Functions
| ShapeAnalysis_FreeBounds ()
| Empty constructor. More...
| ShapeAnalysis_FreeBounds (const TopoDS_Shape &shape, const Standard_Real toler, const Standard_Boolean splitclosed=Standard_False, const Standard_Boolean splitopen=Standard_True)
| Builds forecasting free bounds of the <shape>. <shape> should be a compound of faces. This constructor is to be used for forecasting free edges with help of sewing analyzer BRepAlgo_Sewing which is called with tolerance <toler>. Free edges are connected into wires only when their ends are at distance less than <toler>. If <splitclosed> is True extracts closed sub-wires out of built closed wires. If <splitopen> is True extracts closed sub-wires out of built open wires. More...
| ShapeAnalysis_FreeBounds (const TopoDS_Shape &shape, const Standard_Boolean splitclosed=Standard_False, const Standard_Boolean splitopen=Standard_True, const Standard_Boolean checkinternaledges=Standard_False)
| Builds actual free bounds of the <shape>. <shape> should be a compound of shells. This constructor is to be used for getting free edges (ones referenced by the only face) with help of analyzer ShapeAnalysis_Shell. Free edges are connected into wires only when they share the same vertex. If <splitclosed> is True extracts closed sub-wires out of built closed wires. If <splitopen> is True extracts closed sub-wires out of built open wires. More...
const TopoDS_Compound & | GetClosedWires () const
| Returns compound of closed wires out of free edges. More...
const TopoDS_Compound & | GetOpenWires () const
| Returns compound of open wires out of free edges. More...

## Static Public Member Functions
static void | ConnectEdgesToWires (Handle< TopTools_HSequenceOfShape > &edges, const Standard_Real toler, const Standard_Boolean shared, Handle< TopTools_HSequenceOfShape > &wires)
| Builds sequnce of <wires> out of sequence of not sorted <edges>. Tries to build wires of maximum length. Building a wire is stopped when no edges can be connected to it at its head or at its tail. More...
static void | ConnectWiresToWires (Handle< TopTools_HSequenceOfShape > &iwires, const Standard_Real toler, const Standard_Boolean shared, Handle< TopTools_HSequenceOfShape > &owires)
static void | ConnectWiresToWires (Handle< TopTools_HSequenceOfShape > &iwires, const Standard_Real toler, const Standard_Boolean shared, Handle< TopTools_HSequenceOfShape > &owires, TopTools_DataMapOfShapeShape &vertices)
| Builds sequnce of <owires> out of sequence of not sorted <iwires>. Tries to build wires of maximum length. Building a wire is stopped when no wires can be connected to it at its head or at its tail. More...
static void | SplitWires (const Handle< TopTools_HSequenceOfShape > &wires, const Standard_Real toler, const Standard_Boolean shared, Handle< TopTools_HSequenceOfShape > &closed, Handle< TopTools_HSequenceOfShape > &open)
| Extracts closed sub-wires out of <wires> and adds them to <closed>, open wires remained after extraction are put into <open>. If <shared> is True extraction is performed only when edges share the same vertex. If <shared> is False connection is performed only when ends of the edges are at distance less than <toler>. More...
static void | DispatchWires (const Handle< TopTools_HSequenceOfShape > &wires, TopoDS_Compound &closed, TopoDS_Compound &open)
| Dispatches sequence of <wires> into two compounds <closed> for closed wires and <open> for open wires. If a compound is not empty wires are added into it. More...

## Detailed Description

This class is intended to output free bounds of the shape (free bounds are the wires consisting of edges referenced by the only face). This class works on two distinct types of shapes when analyzing their free bounds:

1. compound of faces. Analyzer of sewing algorithm (BRepAlgo_Sewing) is used for for forecasting free bounds that would be obtained after performing sewing
2. compound of shells. Actual free bounds (edges shared by the only face in the shell) are output in this case. ShapeAnalysis_Shell is used for that.

When connecting edges into the wires algorithm tries to build wires of maximum length. Two options are provided for a user to extract closed sub-contours out of closed and/or open contours.

Free bounds are returned as two compounds, one for closed and one for open wires.

This class also provides some static methods for advanced use: connecting edges/wires to wires, extracting closed sub-wires out of wires, dispatching wires into compounds for closed and open wires. NOTE. Ends of the edge or wire mean hereafter their end vertices.

## Constructor & Destructor Documentation

ShapeAnalysis_FreeBounds::ShapeAnalysis_FreeBounds | ( |  | ) |

Empty constructor.

ShapeAnalysis_FreeBounds::ShapeAnalysis_FreeBounds | ( | const TopoDS_Shape & | shape,
|  | const Standard_Real | toler,
|  | const Standard_Boolean | splitclosed = `Standard_False`,
|  | const Standard_Boolean | splitopen = `Standard_True`
| ) |  |

Builds forecasting free bounds of the <shape>. <shape> should be a compound of faces. This constructor is to be used for forecasting free edges with help of sewing analyzer BRepAlgo_Sewing which is called with tolerance <toler>. Free edges are connected into wires only when their ends are at distance less than <toler>. If <splitclosed> is True extracts closed sub-wires out of built closed wires. If <splitopen> is True extracts closed sub-wires out of built open wires.

ShapeAnalysis_FreeBounds::ShapeAnalysis_FreeBounds | ( | const TopoDS_Shape & | shape,
|  | const Standard_Boolean | splitclosed = `Standard_False`,
|  | const Standard_Boolean | splitopen = `Standard_True`,
|  | const Standard_Boolean | checkinternaledges = `Standard_False`
| ) |  |

Builds actual free bounds of the <shape>. <shape> should be a compound of shells. This constructor is to be used for getting free edges (ones referenced by the only face) with help of analyzer ShapeAnalysis_Shell. Free edges are connected into wires only when they share the same vertex. If <splitclosed> is True extracts closed sub-wires out of built closed wires. If <splitopen> is True extracts closed sub-wires out of built open wires.

## Member Function Documentation

static void ShapeAnalysis_FreeBounds::ConnectEdgesToWires | ( | Handle< TopTools_HSequenceOfShape > & | edges,
|  | const Standard_Real | toler,
|  | const Standard_Boolean | shared,
|  | Handle< TopTools_HSequenceOfShape > & | wires
| ) |  |
| static

Builds sequnce of <wires> out of sequence of not sorted <edges>. Tries to build wires of maximum length. Building a wire is stopped when no edges can be connected to it at its head or at its tail.

Orientation of the edge can change when connecting. If <shared> is True connection is performed only when adjacent edges share the same vertex. If <shared> is False connection is performed only when ends of adjacent edges are at distance less than <toler>.

static void ShapeAnalysis_FreeBounds::ConnectWiresToWires | ( | Handle< TopTools_HSequenceOfShape > & | iwires,
|  | const Standard_Real | toler,
|  | const Standard_Boolean | shared,
|  | Handle< TopTools_HSequenceOfShape > & | owires
| ) |  |
| static

static void ShapeAnalysis_FreeBounds::ConnectWiresToWires | ( | Handle< TopTools_HSequenceOfShape > & | iwires,
|  | const Standard_Real | toler,
|  | const Standard_Boolean | shared,
|  | Handle< TopTools_HSequenceOfShape > & | owires,
|  | TopTools_DataMapOfShapeShape & | vertices
| ) |  |
| static

Builds sequnce of <owires> out of sequence of not sorted <iwires>. Tries to build wires of maximum length. Building a wire is stopped when no wires can be connected to it at its head or at its tail.

Orientation of the wire can change when connecting. If <shared> is True connection is performed only when adjacent wires share the same vertex. If <shared> is False connection is performed only when ends of adjacent wires are at distance less than <toler>. Map <vertices> stores the correspondence between original end vertices of the wires and new connecting vertices.

static void ShapeAnalysis_FreeBounds::DispatchWires | ( | const Handle< TopTools_HSequenceOfShape > & | wires,
|  | TopoDS_Compound & | closed,
|  | TopoDS_Compound & | open
| ) |  |
| static

Dispatches sequence of <wires> into two compounds <closed> for closed wires and <open> for open wires. If a compound is not empty wires are added into it.

const TopoDS_Compound& ShapeAnalysis_FreeBounds::GetClosedWires | ( |  | ) | const

Returns compound of closed wires out of free edges.

const TopoDS_Compound& ShapeAnalysis_FreeBounds::GetOpenWires | ( |  | ) | const

Returns compound of open wires out of free edges.

static void ShapeAnalysis_FreeBounds::SplitWires | ( | const Handle< TopTools_HSequenceOfShape > & | wires,
|  | const Standard_Real | toler,
|  | const Standard_Boolean | shared,
|  | Handle< TopTools_HSequenceOfShape > & | closed,
|  | Handle< TopTools_HSequenceOfShape > & | open
| ) |  |
| static

Extracts closed sub-wires out of <wires> and adds them to <closed>, open wires remained after extraction are put into <open>. If <shared> is True extraction is performed only when edges share the same vertex. If <shared> is False connection is performed only when ends of the edges are at distance less than <toler>.

The documentation for this class was generated from the following file:

- ShapeAnalysis_FreeBounds.hxx